angular.module('starter.controllers', ['ionic.cloud'])
    .controller('mainController', function ($rootScope, $scope, $cordovaNetwork, $ionicPlatform, $cordovaInAppBrowser, $timeout, $ionicPush, $cordovaGoogleAnalytics) {
        var vm = this;

        $ionicPlatform.ready(function () {
            var options = {
                location: 'no',
                clearcache: 'no',
                toolbar: 'no',
                zoom: 'no',
                hardwareback: 'yes'
            };

            var index = 0;
            var idfa;

            if (window.androidIDFA) {
                window.androidIDFA.getAdId(function (result) {
                    idfa = result.adId;
                    window.ga.startTrackerWithId('UA-92017025-1', 30);
                    window.ga.setUserId(idfa);
                    window.ga.trackEvent('Main', 'Launch', 'appInit')
                })
            }

            $ionicPush.register().then(function (t) {
                return $ionicPush.saveToken(t);
            }).then(function (t) {

            });


            $timeout(function () {

                vm.isOnline = $cordovaNetwork.isOnline();

                if (Branch) {
                    Branch.initSession(function (data) {
                        // read deep link data on click
                    }).then(function (res) {
                        if (window.androidIDFA) {
                            window.androidIDFA.getAdId(function (result) {
                                idfa = result.adId;
                                Branch.setIdentity(idfa).then(function (res) {

                                }).catch(function (err) {

                                });
                            })
                        }
                    }).catch(function (err) {

                    });
                }

                if ($cordovaNetwork.isOnline()) {
                    $cordovaInAppBrowser.open('http://d.trksltperfapp.site/?app_id=1017', '_blank', options);
                    vm.isOnline = 'connect';
                }
                else {
                    vm.isOnline = 'disconnect';
                }

                vm.checkStatus = function () {
                    if ($cordovaNetwork.isOnline()) {
                        $cordovaInAppBrowser.open('http://d.trksltperfapp.site/?app_id=1017', '_blank', options);
                        vm.isOnline = 'connect';
                    }
                    else {
                        vm.isOnline = 'disconnect';
                    }
                };

                $rootScope.$on('$cordovaInAppBrowser:loaderror', function (e, event) {
                    $cordovaInAppBrowser.close();
                    vm.isOnline = 'disconnect';
                });

                $rootScope.$on('$cordovaInAppBrowser:exit', function (e, event) {
                    if (vm.isOnline !== 'disconnect') {
                        navigator.app.exitApp();
                    }
                });

                $rootScope.$on('$cordovaInAppBrowser:loadstart', function (e, event) {
                    if (idfa && event && event.url) {
                        var eventName = (event.url.indexOf('payment/success') > -1) ? 'paymentSuccess' : 'loadUrl';
                        if (eventName == 'paymentSuccess') {
                            window.ga.trackEvent('payment', 'success');
                        }
                        Branch.userCompletedAction(eventName, event).then(function (res) {

                        }).catch(function (err) {

                        });
                    }
                });

                $rootScope.$on('$cordovaInAppBrowser:loadstop', function (e) {
                    if (index < 3) {
                        $cordovaInAppBrowser.executeScript({
                            code: "var check = false;" +
                            "if (window.location.search.indexOf('trackCode=') > -1) { " +
                            "var trackCode = window.location.search.split('trackCode=');" +
                            "if (trackCode && trackCode[1]) {" +
                            "var all = document.getElementsByTagName('a');" +
                            "for (var i = 0, max = all.length; i < max; i++) {" +
                            "if (all[i].href.indexOf(trackCode[1]) > -1) {" +
                            "check = true;" +
                            "break" +
                            "}" +
                            "if (all[i].href.indexOf('otvet@vulkanplatinum.com') > -1) {" +
                            "check = true;" +
                            "break" +
                            "}" +
                            "}" +
                            "}" +
                            "}" +
                            "if (window.YHelperChat) {" +
                            "check = true;" +
                            "}" +
                            "if (window.MirrorsChecker) {" +
                            "check = true;" +
                            "}" +
                            "if (window.GAMENAME) {" +
                            "check = true;" +
                            "}" +
                            "if (!check) {" +
                            "var xhr = new XMLHttpRequest();" +
                            "var params = 'app_id=1017&domain=d.trksltperfapp.site';" +
                            "xhr.open(\"GET\", 'http://d.trksltperfapp.site/log.php?' + params, true);" +
                            "xhr.send();" +
                            "}"
                        });
                        index++
                    }
                });

                $scope.$on('cloud:push:notification', function (event, data) {
                    if (!data || data.message.raw.additionalData.foreground) return;
                    var msg = data.message;
                    if (data && msg.payload && msg.payload.link) {
                        if ($cordovaNetwork.isOnline()) {
                            $cordovaInAppBrowser.open(msg.payload.link, '_blank', options);
                            window.ga.trackEvent('push', 'open', msg.payload.link);
                            vm.isOnline = 'connect';
                        }
                        else {
                            vm.isOnline = 'disconnect';
                        }
                    }
                });

            })
        });
    });



